/*********************************************************************************************
 * (c) COPYRIGHT 2020 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * System Logger Definitions HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : SysLoggerDefinitions.h
 * CREATION DATE : Mar 27, 2020
 * TARGET        : embedded Linux
 *
 *********************************************************************************************/
#ifndef _SYSLOGGERDEFINITIONS_H_
#define _SYSLOGGERDEFINITIONS_H_

/**
* \ingroup SysLogger
* \defgroup SysLoggerDefinitions System Logger Definitions
* Provides the overall SysLogger definitions.
*/

#ifdef __cplusplus
extern "C" {
#endif

/*********************************************************************************************
 *        GLOBAL DECLARATIONS
 *********************************************************************************************/

/** Facility definition */
typedef enum __SysLogFacility
{
    SYSLOG_FACILITY_ROUTER = 0,
    SYSLOG_FACILITY_MAX
} SysLogFacility_t;

/** Max sys log message length */
#define SYSLOG_MAX_MSG_LENGTH           (size_t)512

/** Max logger name length */
#define SYSLOG_MAX_LOGGER_NAME_LENGTH   (size_t)32

/** Max number of loggers supported */
#define SYSLOG_MAX_NBR_OF_LOGGERS       (size_t)64



#ifdef __cplusplus
}
#endif

#endif /* _SYSLOGGERDEFINITIONS_H_ */
/************************************END OF FILE*********************************************/
