/*********************************************************************************************
 * (c) COPYRIGHT 2020 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * Customized Assertion Handler HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : assertion.h
 * CREATION DATE : Mar 27, 2020
 * TARGET        : embedded Linux
 *
 *********************************************************************************************/

#ifndef _SYS_ASSERTION_H_
#define _SYS_ASSERTION_H_

/** @ingroup libnmapp
 * @defgroup assertion Customized Assertion
 * Provides a customized assertion handler logging the assertion. This is makes debugging
 * easier.
 */

#include <assert.h>

/*********************************************************************************************
 *        GLOBAL DECLARATIONS
 *********************************************************************************************/

#if(!defined(__TEST))
    #undef assert
    extern void __nm_assert(const char* _expr, const char *_file, int _line, const char* _function);
    #define assert(expr)    \
            ((expr) ? (void)0 : __nm_assert(#expr, __FILE__, __LINE__, __func__))
#endif

#endif /* _SYS_ASSERTION_H_ */

/************************************END OF FILE*********************************************/
