/*********************************************************************************************
 * (c) COPYRIGHT 2020 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * IFileOperation-protected HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : IFileOperation-protected.h
 * CREATION DATE : Apr 2, 2020
 * TARGET        : general
 *
 *********************************************************************************************/
#ifndef _FILE_IFILEOPERATION_PROTECTED_H_
#define _FILE_IFILEOPERATION_PROTECTED_H_

#include <nmapp/file/IFileOperation.h>

#ifdef __cplusplus
extern "C" {
#endif


/*********************************************************************************************
 *        PROTECTED DECLARATIONS
 *********************************************************************************************/

typedef struct __IFileOperationProtected
{
    IFileOperationImplRef myImpl;
    bool (*isFileOpen)(IFileOperationImplRef implRef);
    void (*openFile)(IFileOperationImplRef implRef, const char* fileName, const char* modes);
    void (*closeFile)(IFileOperationImplRef implRef);
    const char* (*getFileName)(IFileOperationImplRef implRef);
    void (*writeToFile)(IFileOperationImplRef implRef, const char* data, uint32_t size);
    void (*writeUpdateToFile)(IFileOperationImplRef implRef, bool withTruncate, uint32_t atOffset, const char* data, uint32_t size);
    void (*readFromFile)(IFileOperationImplRef implRef, char* buffer, uint32_t size, uint32_t offset);
    void (*readLineFromFile)(IFileOperationImplRef implRef, uint32_t lineNbr, char* buffer, uint32_t size);
    void (*moveFile)(IFileOperationImplRef implRef, const char* srcFileName, const char* dstFileName);
    void (*copyFile)(IFileOperationImplRef implRef, const char* srcFileName, const char* dstFileName);
    void (*deleteFilePath)(IFileOperationImplRef implRef, const char* filePath);
    void (*createDirectory)(IFileOperationImplRef implRef, const char* dirPath, uint32_t permissions);
    bool (*isExist)(IFileOperationImplRef implRef, const char* fileName);
    bool (*isDirectory)(IFileOperationImplRef implRef, const char* path);
    int  (*getFiledescriptor)(IFileOperationImplRef implRef);
} IFileOperationProtected_t;


/*********************************************************************************************
 *        PROTECTED FUNCTIONS
 *********************************************************************************************/


#ifdef __cplusplus
}
#endif

#endif /* _FILE_IFILEOPERATION_PROTECTED_H_ */
