/*********************************************************************************************
 * (c) COPYRIGHT 2020 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * temperature private HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : temperature-private.h
 * CREATION DATE : Apr 9, 2020
 * TARGET        : generic
 *
 *********************************************************************************************/
#ifndef _TEMPERATURE_PRIVATE_H_
#define _TEMPERATURE_PRIVATE_H_

#include <nmapp/sensor/temperature.h>

#ifdef __cplusplus
extern "C" {
#endif


/*********************************************************************************************
 *        GLOBAL DECLARATIONS
 *********************************************************************************************/

#define TEMP_MAX_BUFFER_SIZE  64

#define TEMP_NONE_NAME       ""
#define TEMP_SYS_NAME        "system"
#define TEMP_ENV_NAME        "environment"



typedef struct __TemperaturePrivate
{
    TemperatureId_t   sensorId;
    IFileOperationRef fileOpRef;
    const char*       sensorPath;
    bool              wasFileOpen;
    ILogRef           logRef;
    char              sensorName[TEMP_MAX_BUFFER_SIZE];
} TemperaturePrivate_t;



/*********************************************************************************************
 *        GLOBAL FUNCTIONS
 *********************************************************************************************/

#ifdef __cplusplus
}
#endif

#endif /* SRC_SENSOR_TEMPERATURE_PRIVATE_H_ */
