/*********************************************************************************************
 * (c) COPYRIGHT 2021 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * IUnixInitSys-protected HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : IUnixInitSys-protected.h
 * CREATION DATE : Jan 20, 2021
 * TARGET        : general
 *
 *********************************************************************************************/
#ifndef _SYS_IUNIXINITSYS_PROTECTED_H_
#define _SYS_IUNIXINITSYS_PROTECTED_H_

#include <nmapp/sys/IUnixInitSys.h>

#ifdef __cplusplus
extern "C" {
#endif


/*********************************************************************************************
 *        PROTECTED DECLARATIONS
 *********************************************************************************************/

typedef struct __IUnixInitSysProtected
{
    IUnixInitSysImplRef myImpl;
    void  (*logMessage)(IUnixInitSysImplRef implRef, int32_t logPriority, int32_t facility, const char* loggerName, const char* msg);
    void  (*initDBus)(IUnixInitSysImplRef implRef);
    void  (*deinitDBus)(IUnixInitSysImplRef implRef);
    int   (*getEventFd)(IUnixInitSysImplRef implRef);
    void  (*registerDBusSignalCallback)(IUnixInitSysImplRef implRef, UnixInitSysDBusSignalItemCallback cbFn, void* pCbCtx);
    void  (*activateDBusListener)(IUnixInitSysImplRef implRef);
    void  (*processDBusEvents)(IUnixInitSysImplRef implRef);
    void* (*registerDBusSignalMatch)(IUnixInitSysImplRef implRef, const char* dbusService, const char* dbusObjPath,
                                     const char* dbusItfName, const char* dbusSignalName);
    void  (*unregisterDBusSignalMatch)(IUnixInitSysImplRef implRef, void* signalMatchRef);
    const char* (*getOperatingState)(IUnixInitSysImplRef me);
} IUnixInitSysProtected_t;


/*********************************************************************************************
 *        PROTECTED FUNCTIONS
 *********************************************************************************************/


#ifdef __cplusplus
}
#endif

#endif /* _SYS_IUNIXINITSYS_PROTECTED_H_ */
