/*********************************************************************************************
 * (c) COPYRIGHT 2020 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * Customized Assertion Handler
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : assertion.c
 * CREATION DATE : Mar 27, 2020
 * TARGET        : embedded Linux
 *
 *********************************************************************************************/


#include <stdlib.h>     // for exit()

#include <nmapp/types/nm-types.h>
#include <nmapp/logging/ILog.h>
#include <nmapp/sys/assertion.h>

//--------------------------------------------------------------------------------------------
void __nm_assert(const char* _expr, const char *_file, int _line, const char* _function)
{
    ILog_msg(NULL, LOG_LEVEL_EMCY, "Assertion '%s': function=%s, line=%d, file=%s", _expr, _function, _line, _file);
    exit(EXIT_FAILURE);
}
